//+------------------------------------------------------------------+
//|                                             Stochastic_v2.mq4.mq4|
//|                                                            NoName|
//|                                                                  |
//|                              http://www.tradersforum.net.ru/forum|
//+------------------------------------------------------------------+----+
//| LimitCross=true  -      |
//|                                            |
//|           false  -               |
//+-----------------------------------------------------------------------+
//|   v2:                                                          |
//| -     Buy;                             |
//| -   nvelopes,                |
//|   (  );                                         |
//| -    .         |
//|      .                                         |
//+-----------------------------------------------------------------------+
#property copyright "NoName"
#property link      "http://www.tradersforum.net.ru/forum"
//-------------------------------------------------------------------

//=============== input parameters =======================================
extern int     ExpertID            =1111;         // 
extern int     Stoch_period        =14;
extern int     Env_period          =25;
extern int     Env_shift           =1;
extern double  Env_deviation       =20;
extern bool    LimitCross          =false;
//---------------------------------------
extern int     TP=30;
extern int     SL=30;
//extern double  Lot=0.1;
extern int     Slippage=3;
//--------
extern string _Parameters_Trailing = "-----   -----";
extern bool UseTrailing    = false;   //  
extern bool ProfitTrailing = false;   //     
extern int  TrailingStop   = 15;      //   
extern int  TrailingStep   = 2;       //  
//========================================================================
int   up_lim  =75;     // 
int   low_lim =25;     // 
//----------------
double Env_low[2];
double Env_up [2];
//double Stochastic[2};
//-------------------
color    clModifyBuy  = Green;
color    clModifySell = Blue;
//--   --
#include  <b-Lots.mqh> 
//---------------------------

//*********************************************************************

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if (Env_deviation==0) Env_deviation=0.1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

////////////////////////////////////////////////////////////////////////////////////////////////
//|                     START FUNCTION BEGIN                                                 ///
////////////////////////////////////////////////////////////////////////////////////////////////
int start()
  {
  
//================================================================
bool NextBar=false;
datetime CloseTime=0;
int _OrdersHistoryTotal=OrdersHistoryTotal();
//----------------------------------------------------------
  for (int i=0; i<_OrdersHistoryTotal; i++) { 
     if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) {
       if (OrderSymbol()==Symbol()) {
         if (OrderMagicNumber() == ExpertID) {
            CloseTime= MathMax(CloseTime, OrderCloseTime());
         }
       }
     } 
   }
  //-------------------------------------------------------------------
  int Bar; 
  if (CloseTime==0){Bar=1;}
  else             {Bar=iBarShift(NULL, 0, CloseTime, false);}
  //-------------------------------------------------------------------
  if (Bar!=0) NextBar=true;  
//============================================================================  
  
if (NextBar) {
//==============================================================================================
double Stochastic[49];
//--------------------------
for ( i=0; i<50; i++) {
Stochastic[i]= iStochastic(NULL, 0, Stoch_period, 3,3,MODE_SMA,0,MODE_MAIN, i); }
ArraySetAsSeries (Stochastic, true);
//----------------------------------------------------------------------------------------------
//Env_low[0]=iEnvelopesOnArray(Stochastic,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,0);
//Env_up [0]=iEnvelopesOnArray(Stochastic,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,0);

Env_low[0]=iMAOnArray (Stochastic, 0,Env_period, Env_shift, MODE_SMA, 0) - Env_deviation;
Env_up [0]=iMAOnArray (Stochastic, 0,Env_period, Env_shift, MODE_SMA, 0) + Env_deviation;
 
//----------------------------------------------------------------------------------------------

Comment ("Stochastic[0] ",  Stochastic[0] , "\n",
         "Env_up [0]    ",  Env_up [0]    , "\n",
         "Env_low[0]    ",  Env_low[0]    , "\n" );
         
//----------------------------------------------------------------------------------------------

  //----   -----
  if   (  (Stochastic[1]<Env_low[0])  &&
          (Stochastic[0]>Env_low[0])  ){
          
    if (isExpertOrder()==0) { //    
      Buy ();             //
    } 
    else {                //   
    
     if ((Stochastic[0] > low_lim) && (Stochastic[0] < up_lim)) {  
      
       if (ClosePosition(1)) { Buy (); }   // Sell.  Buy.
                       
      } 
    }
  }  
  //----   ----
  if  (   (Stochastic[1]>Env_up[0])  &&
          (Stochastic[0]<Env_up[0])  ){
          
    if (isExpertOrder()==0) { //    
      Sell ();                //
    } 
    else {                    //     
    
     if ((Stochastic[0] > low_lim) && (Stochastic[0] < up_lim)) {
     
       if (ClosePosition(0)) { Sell (); } // Buy.  Sell.
                      
      }
    }
  }  
//========================================================================
//====        ====
//========================================================================
if (LimitCross) {
  if (isExpertOrder()==1) { //    
    if (Stochastic[0] > Env_up[0]) {
        ClosePosition(0); 
     }
   }
  if (isExpertOrder()==2) { //    
    if (Stochastic[0] < Env_low[0]) {
        ClosePosition(1);
     }
   }
}
//========================================================================
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////                          TRAILING  STOP                               ////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
if (UseTrailing == True)
{
bool   fm;
int    err;
double ldOpen=0;
double ldTake=0;

for (i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==ExpertID) {
        if (OrderType()==OP_BUY) {
          if (!ProfitTrailing || (Bid-OrderOpenPrice())>TrailingStop*Point) {
            if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
              //ModifyStopLoss(Bid-TrailingStop*Point, clModifyBuy);
              
                ldOpen=OrderOpenPrice();
                ldTake=OrderTakeProfit();
        
              if (IsTradeAllowed()) {
              fm=OrderModify(OrderTicket(), ldOpen, Bid-TrailingStop*Point, ldTake, 0, clModifyBuy);
              if (!fm) {
              err=GetLastError();
              Print("Error(",err,") modifying SL: ");
              }
             }
  
            }
          }
        }
        if (OrderType()==OP_SELL) {
          if (!ProfitTrailing || OrderOpenPrice()-Ask>TrailingStop*Point) {
            if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
              //ModifyStopLoss(Ask+TrailingStop*Point, clModifySell);
              
                ldOpen=OrderOpenPrice();
                ldTake=OrderTakeProfit();
              
              if (IsTradeAllowed()) {
              fm=OrderModify(OrderTicket(), ldOpen, Ask+TrailingStop*Point, ldTake, 0, clModifySell);
              if (!fm) {
              err=GetLastError();
              Print("Error(",err,") modifying SL: ");
              }
             } 
 
            }
          }
        }
      }
    }
  }
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////                  end of  TRAILING  STOP                               ////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
  


  return(0);
}
////////////////////////////////////////////////////////////////////////////////////////////////
//|                        START FUNCTION END                                                ///
////////////////////////////////////////////////////////////////////////////////////////////////


//==========================================================================================================
void Buy () {

Lots=GetSizeLot(); 

int ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Bid-SL*Point,Ask+TP*Point,"Stochastic",ExpertID,0,CLR_NONE);
if    (ticket<0) { Print("   BUY #", GetLastError()); return (0); }  
}
//==========================================================================================================
void Sell () {

Lots=GetSizeLot();   
   
int ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,"Stochastic",ExpertID,0,CLR_NONE);
if (ticket<0) { Print("   SELL #", GetLastError()); return (0); } 
}
//=======================================================================================
//|     .           |=============================
//| ----                                                   |=============================
//|   OP_BUY     0              |=============================
//|   OP_SELL    1              |=============================
//=======================================================================================
bool ClosePosition (int OP) {

string op_type;
double ClosePrice;
if (OP==0) {op_type="OP_BUY";  ClosePrice=Bid; }  
if (OP==1) {op_type="OP_SELL"; ClosePrice=Ask; } 

  for (int i=0; i<OrdersTotal(); i++) {      
     if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
       if (OrderSymbol()==Symbol()) {
         if (OrderMagicNumber()==ExpertID) {
           if (OrderType()==OP) {
             if (OrderClose (OrderTicket(), OrderLots(), ClosePrice, Slippage, 0) == false) {
             
               Print("   ",op_type, " #", GetLastError()); 
               return(false);
              }
              else return(true);
            }
          }
        }
      }
    }
  }
//=======================================================================================
//|      |==========================================
//| 0 -                             |==========================================
//| 1 -   Buy                        |==========================================
//| 2 -   Sell                       |==========================================
//=======================================================================================
int isExpertOrder() {

 int _OrdersTotal=OrdersTotal();
 for (int i=0; i<_OrdersTotal; i++) { 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol()) {
        if (OrderMagicNumber()==ExpertID) {
          if (OrderType()==OP_BUY) {
             return(1); break; }
          if (OrderType()==OP_SELL) {
             return(2); break; }
         }   
       }     
     }   
   }  
}
//=======================================================================================  